$DEBUG
C                     ----- Thermodynamic Data Cal. PROGRAM -----
C         CPAIRA.for  SYTBL2.for  ( '05-2-11 )
C
      COMMON/SYIAE/RM,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
C
      DIMENSION AT(500),ACP(500),AH(500),AS(500),AU(500),PR(500),VR(500)
     /,AK(500),AKR(500)
C
C
      UR=8.31433            ! (kJ/kmol K)
      AM=28.967             ! (kg/kmol)
C
      G=9.80665
      CJK=4.1868            ! (kJ/kcal)
C
      R=UR/AM               ! (kJ/kg K)
      RM=R/CJK              ! (kcal/kg K)
C
      ND=1         !  ND=1 for SI, 2 for Metric , 3 for British Units.
      CK=0.0       !  for Constant k
C
C                   -------Ref. only-------------
      GC=1.0
      AFST=14.653
      ALHV=10300.           ! (kcal/kg)
      BLHV=ALHV*CJK         ! (kJ/kg)
C
      TC=273.15
      TSTD=288.15
      PSTD=0.101322
      BT=1000.0
C----------------------------------------------------------------------
      TF=0.0
      TL=5000.0
      DT=20.0
      F=0.0
C
      NF=TF
      NL=TL
C
   10 N=1
      NF=N
      T=TF
      GO TO 20
C
   12 T=T+DT
      NL=N
C
   20 CALL CPT(T,F,CP,AKX)
      AKRX=R/CP
      IF(ND.EQ.2.OR.ND.EQ.3)AKRX=R/CP/CJK
      CALL HFT(T,F,H)
      CALL SFT(T,F,S)
      CALL UFT(T,F,U)
      CALL PRT(T,F,PRX)
      CALL VRT(T,F,VRX)
C
      AT(N)=T
      ACP(N)=CP
      AK(N)=AKX
      AKR(N)=AKRX
      AH(N)=H
      AS(N)=S
      AU(N)=U
      PR(N)=PRX
      VR(N)=VRX
C
      IF(N.GT.1) GO TO 60
C
   30 IF(ND-2) 32,34,36
   32 WRITE(6,110)CK,ND,F
      GO TO 38
C
   34 WRITE(6,112)CK,ND,F
      GO TO 38
C
   36 WRITE(6,114)CK,ND,F
C
   38 WRITE(6,120)
C
   60 WRITE(6,130)AT(N),ACP(N),AH(N),AS(N),AU(N),PR(N),VR(N),AK(N),AKR(N
     /)
      GO TO 80
C
   70 WRITE(6,140)AT(N),ACP(N),AH(N),AS(N),AU(N),PR(N),VR(N),AK(N),AKR(N
     /)
C
   80 N=N+1
      IF(T.GE.TL) GO TO 99
      IF(T.GE.500.0) GO TO 84
      GO TO 12
C
   82 IF(T.GE.500.)GO TO 84
      DT=50.0
      GO TO 12
C
   84 DT=100.0
      GO TO 12
C
  110 FORMAT(10X,'***  Gas Table (SI Unit) ***',8X,'CK=',F5.3,4X,'ND=',I
     /2,4X,'F=',F7.5,/)
  112 FORMAT(10X,'***  Gas Table (Metric Unit) ***',8X,'CK=',F5.3,4X,'ND
     /=',I2,4X,'F=',F7.5,/)  
  114 FORMAT(10X,'***  Gas Table (British Unit) ***',8X,'CK=',F5.3,4X,'N
     /D=',I2,4X,'F=',F7.5,/)  
  120 FORMAT(6X,'T(K)',6X,'CP',10X,'H',9X,'PHI',7X,'U',11X,'PR',10X,'VR'
     /,8X,'K',6X,'(K-1)/K')
  130 FORMAT(F10.2,F10.5,F12.3,F10.4,F10.3,2E12.5,F10.4,F10.5)
  140 FORMAT(F10.2,F10.5,F12.3,F10.4,F10.3,2F12.4,F10.4,F10.5)
C
   99 STOP
  100 END
