DEBUG
C                     ----- Thermodynamic Data Cal. PROGRAM -----
C         CPCALA.for  SYTBL2..for  ( '05-2-9 )                Arranged by M. Iwai
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      UR=8.31433            ! (kJ/kmol K)
      AM=28.967             ! (kg/kmol)
C
      G=9.80665
      CJK=4.1868            ! (kJ/kcal)
C
      R=UR/AM               !=0.2870 (kJ/kg K)
      RC=R/CJK              !=0.06856 (kcal/kg K)=RM/J=RB/JB
C
      ND=1         !  ND=1 for SI, 2 for Metric , 3 for British Units.
      CK=0.0       !  for Constant k
C
C ------------The above are to be copied into the main program-------------
      GC=1.0
      AFST=14.653           ! air/fuel ratio
      ALHV=10300.           ! (kcal/kg)
      BLHV=43000.           ! ALHV*CJK (kJ/kg)
      CLHV=18400.           ! (Btu/lb)
C
      RM=29.27              !=UR*1000./(AM*G) (kg-m/kg-K)
      J=426.9               !=CJK*1000./G  (kg-m/kcal)
      RB=53.35              !=RM/(1.8*0.3048) (ft-lb/lb-R) 
      JB=778.2              !=CJK*1000./(G*1.8*0.3048) (ft-lb/lb-R) 
C
      TC=273.15
      TSTD=288.15
      PSTD=101.322
      BT=1000.0
C          ----------------------------------------------
C

    2 WRITE(*,*)' I,   ( T: H: U: Pr: Vr ),    F  ??? '
      WRITE(*,*)
C
      READ(*,*)I,X,F
C
      IF(I.EQ.0.OR.I.GE.6) GO TO 99
      IF(X.EQ.0.0) GO TO 27
C
      FX=F
      F=ABS(F)
      IF(F.LT.0.09) GO TO 10
      IF(F-2.0)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
C
    6 F=1.0/F            !  for F= (A/F)
C
C
   10 GO TO (11,12,13,14,15),I
      GO TO 27
C
   11 T=X
      IF(T.GT.5200.0) GO TO 27
      GO TO 20
C
   12 H=X
      IF(H.GT.7000.0) GO TO 27
      CALL TFH(H,F,T)
      GO TO 20
C
   13 U=X
      IF(U.GT.5500.0) GO TO 27
      CALL TFU(U,F,T)
      GO TO 20
C
   14 PR=X
      IF(PR.GT.0.5e6) GO TO 27
      CALL TPR(PR,F,T)
      GO TO 20
C
   15 VR=X
      IF(VR.LT.0.02) GO TO 27
      CALL TVR(VR,F,T)
C
   20 CALL CPT(T,F,CP,AK)
      CALL HFT(T,F,H)
      CALL SFT(T,F,S)
      CALL UFT(T,F,U)
      CALL PRT(T,F,PR)
      CALL VRT(T,F,VR)
C
      WRITE(*,*)
      WRITE(*,30)T,CP,H,VR,U
C
      IF(FX.LT.0.09) GO TO 25
      IF(FX.GT.2.0) GO TO 26
C
   24 WRITE(*,31)FX,AK,S,PR,AKR
      GO TO 2
C
   25 WRITE(*,32)F,AK,S,PR,AKR
      GO TO 2
C
   26 WRITE(*,33)FX,AK,S,PR,AKR
      GO TO 2
C
   27 WRITE(*,34)
      GO TO 2
C
   30 FORMAT(6X,'T=',F8.3,3X,'CP=',F8.6,4X,'H=',F8.3,3X,'VR=',E12.5,4X,'
     /U =',F8.3,/)
   31 FORMAT(1X,'R(F/A)=',F8.5,3X,'K =',F8.5,2X,'PHI=',F8.5,3X,'PR=',E11
     /.4,1X,'(K-1)/K=',F7.5,//)
   32 FORMAT(4X,'F/A=',F8.5,3X,'K =',F8.5,2X,'PHI=',F8.5,3X,'PR=',E11.4,
     /1X,'(K-1)/K=',F7.6,//)
   33 FORMAT(4X,'A/F=',F8.5,3X,'K =',F8.5,2X,'PHI=',F8.5,3X,'PR=',E11.4,
     /1X,'(K-1)/K=',F7.5,//)
   34 FORMAT(5X,'INPUT ERROR ?')
C
   99 STOP
  100 END


