$DEBUG
C                     ----- One Dimentional Flow Cal. PROGRAM -----
C         FLCALH.for  TBLD26.for  ( '02-12-26 )                 Arranged by M. Iwai
C
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
C
      UR=8.31433            ! (kJ/kmol K)
      AM=28.967             ! (kg/kmol)
C
      G=9.80665
      CJK=4.1868            ! (kJ/kcal)
C
      R=UR/AM               !=0.2870277 (kJ/kg K)
      RC=R/CJK              !=0.0685554 (kcal/kg K)=RM/J=RB/JB
C
C      ND=1         !  ND=1 for SI, 2 for Metric , 3 for British Units.
C      CK=0.0       !  for Constant k
C
C ------------The above are to be copied into the main program-------------
C
      GC=1.0
      AFST=14.653           ! air/fuel ratio
      ALHV=10300.           ! (kcal/kg)
      BLHV=43000.           ! ALHV*CJK (kJ/kg)
      CLHV=18400.           ! (Btu/lb)
C
      RM=29.27              !=UR*1000./(AM*G) (kg-m/kg-K)
      J=426.9               !=CJK*1000./G  (kg-m/kcal)
      RB=53.35              !=RM/(1.8*0.3048) (ft-lb/lb-R) 
      JB=778.2              !=CJK*1000./(G*1.8*0.3048) (ft-lb/lb-R) 
C
      TC=273.15
      TSTD=288.15
      PSTD=101.322
      BT=1000.0

C                    ------------------
C
    2 WRITE(*,*)'CK,ND,J,( Mn:PsR:PtR:  TsR:RsR:VfT:  Q:Qs:AsR:  SQ:SAs
     /R ),  T,   F   ???'          !        --- SQ, SAsR for Mn>1.0---
      READ(*,*)CK,ND,J,X,T,F
      WRITE(*,49)
C
      IF(J.EQ.0.OR.J.GT.11) GO TO 37
      IF(X.LT.0.0) GO TO 37
      IF(T.GT.5200.0) GO TO 37
C
      FX=F
      F=ABS(F)
      IF(F.LT.0.09) GO TO 9
      IF(F-2.0)4,4,6
    4 F=F/AFST           ! for Phi
      GO TO 9
    6 F=1.0/F            !  for F= (A/F)
C
    9 X=ABS(X)
C
   10 GO TO (11,12,13,14,15,16,17,18,19,20,21),J
C
   11 AMN=X
      CALL FMN(AMN,F,T)
      GO TO 30
C
   12 PSPT=X
      IF(X.GT.1.0) GO TO 37
      CALL PSR(PSPT,F,T)
      GO TO 30
C
   13 PTPS=X
      IF(X.LT.1.0) GO TO 37
      CALL PTR(PTPS,F,T)
      GO TO 30
C
   14 TSTT=X
      IF(X.GT.1.0) GO TO 37
      CALL TSR(TSTT,F,T)
      GO TO 30
C
   15 RSRT=X
      IF(X.GT.1.0) GO TO 37
      CALL RSR(RSRT,F,T)
      GO TO 30
C
   16 VRTT=X
      CALL VFT(VRTT,F,T)
      GO TO 30
C
   17 QT=X
      CALL FQT(QT,F,T)
      GO TO 30
C
   18 QS=X
      CALL FQS(QS,F,T)
      GO TO 30
C
   19 ASAT=X
      IF(X.LT.1.0) GO TO 37
      CALL ASR(ASAT,F,T)
      GO TO 30
C
   20 SQT=X
      CALL SFQT(SQT,F,T)
      GO TO 30
C
   21 SASAT=X
      IF(X.LT.1.0) GO TO 37
      CALL SASR(SASAT,F,T)
      GO TO 30
C
   30 WRITE(*,64)T,TSX,CPMX,AKMX,AKRMX
      WRITE(*,65)AMNX,PSPTX,TSTTX,VRTX,QX
      WRITE(*,66)F,PTPSX,RSRTX,ASATX,QSX
C
      GO TO 2
C
   37 WRITE(*,54)
      GO TO 2
C
   49 FORMAT(/)
   50 FORMAT(5X,'Tt=',F8.3,3X,'Cp=',F8.6,4X,'H=',F8.3,3X,'Vr=',F11.6,5X,
     /'U =',F8.3,/)
   51 FORMAT(1X,'R(F/A)=',F8.5,3X,'K =',F8.6,2X,'PHI=',F8.6,3X,'Pr=',F11
     /.5,1X,'(K-1)/K=',F7.5,//)
   52 FORMAT(4X,'F/A=',F8.5,3X,'K =',F8.6,2X,'PHI=',F8.6,3X,'Pr=',F11.5,
     /1X,'(K-1)/K=',F7.5,//)
   53 FORMAT(4X,'A/F=',F8.5,3X,'K =',F8.6,2X,'PHI=',F8.6,3X,'Pr=',F11.5,
     /1X,'(K-1)/K=',F7.5,//)
   54 FORMAT(5X,'INPUT ERROR ?')
   64 FORMAT(5X,'Tt=',F8.3,2X,'Ts=',F8.3,3X,'CPm =',F8.5,3X,'Km=',F7.5,1
     /X'(Km-1)/Km=',F6.5,/)
   65 FORMAT(5X,'Mn=',F6.3,2X,'P/Pt=',F8.5,3X,'Ts/T =',F7.5,2X,'V/RTt=',
     /F8.4,3X,'Q =',F8.5,/)
   66 FORMAT(3X,'F/A=',F8.5,1X,'Pt/P=',F10.4,1X,'RO/ROt=',F7.5,1X,'A/At=
     /',F9.4,1X,'Qs=',F10.5,//)
C
   99 STOP
  100 END

