DEBUG
C              ***** SYTBL2.for *****  2005-4-5
C                                   Developed by M. Iwai
C              
C                                                  (( THERMODYNAMIC TABLES ))
C******************************************************************************
C---------*** Eq.(1); CPT ***--------------------------------------------------
C
      SUBROUTINE CPT(T,F,CP,AK)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION CPA,DELCP
C
      IF(ND.EQ.3)T=T/1.8
      RTEMP=5200.0
      IF(T.GT.RTEMP) T=RTEMP
      IF(F.GT.1.4.AND.F.LE.10.0)GO TO 190
      IF(CK.NE.0.0)GO TO 200
      DELCP=0.0
C
      F=ABS(F)
      IF(F.LT.0.1) GO TO 10
      IF(F-1.4)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
    6 F=1.0/F            !  for F= (A/F)
   10 FARR=F/(1.0+F)
C          ********************
      IF(T.LT.0.0) T=ABS(T)
      IF(T.GT.RTEMP) T=RTEMP
   12 IF(T-200.)110,14,14
   14 IF(T-800.)120,16,16
   16 IF(T-2200.)130,140,140
C          *********************
  110 CPA=1.00170E+00+T*(3.38308E-06+T*(5.87761E-09+T*(-2.64387E-10+T*(1
     /.03862E-12))))    
      IF(FARR.LE.0.0) GO TO 150
C
      DELCP=7.25169E-02+T*(3.53289E-03+T*(-2.24872E-05+T*(1.13663E-07+T*
     /(-1.62284E-10))))
      GO TO 150
C
  120 CPA=1.0189130E+00+T*(-1.3783640E-04+T*(1.9843400E-07+T*(4.2399240E
     /-10+T*(-3.7632490E-13))))
      IF(FARR.LE.0.0) GO TO 150
C
      DELCP=-3.5949410E-01+T*(4.5163990E-03+T*(2.8116360E-06+T*(-2.17087
     /30E-08+T*(2.8688780E-11+T*(-1.2226340E-14)))))
      GO TO 150
C
  130 CPA=7.9865510E-01+T*(5.3392160E-04+T*(-2.2881690E-07+T*(3.7420860E
     /-11)))
      IF(FARR.LE.0.0) GO TO 150
C
      DELCP=1.0887570E+00+T*(-1.4158830E-04+T*(1.9160160E-06+T*(-1.24009
     /30E-09+T*(3.0166950E-13+T*(-2.6117110E-17)))))
      GO TO 150
C
  140 CPA=8.852846E-01+T*(3.702210E-04+T*(-1.349033E-07+T*(2.368343E-11+
     /T*(-1.580984E-15))))
      IF(FARR.LE.0.0) GO TO 150
C
      DELCP=3.828289E-02+T*(2.714380E-03+T*(-1.017066E-06+T*(1.722610E-1
     /0+T*(-1.103124E-14))))
C
  150 CP=CPA+FARR*DELCP
      AK=1.0/(1.0-R/CP)
      AKR=R/CP
      IF(ND.EQ.2.OR.ND.EQ.3)AKR=RC*CJK/CP
      GO TO 160
C
  190 CP=1.0
      AK=0.0
      AKR=0.0
      GO TO 160
C
  200 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
C
  160 IF(ND.EQ.2.OR.ND.EQ.3)CP=CP/CJK
      IF(ND.EQ.3)T=1.8*T
C
      RETURN
      END

C--------- *** Eq.(2); HFT ***------------------------------------------------
C
      SUBROUTINE HFT(T,F,H)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION HA,DELH
C
      IF(ND.EQ.3)T=T/1.8
      RTEMP=5200.0
      IF(T.GT.RTEMP) T=RTEMP
      IF(F.GT.1.4.AND.F.LE.10.0)GO TO 262
      IF(CK.NE.0.0)GO TO 260
      DELH=0.0
C
      F=ABS(F)
      IF(F.LT.0.10) GO TO 10
      IF(F-1.4)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
    6 F=1.0/F            !  for F= (A/F)
   10 FARR=F/(1.0+F)
C          *******************
      IF(T.LT.0.0) T=ABS(T)
      IF(T.GT.RTEMP) T=RTEMP
      IF(T.EQ.0.0) GO TO 255
   12 IF(T-200.)210,14,14
   14 IF(T-800.)220,16,16
   16 IF(T-2200.)230,240,240
C          ********************
C
  210 HA=-2.18081E-01+T*(1.00170E+00+T*(3.38308E-06/2.+T*(5.87761E-09/3.
     /+T*(-2.64387E-10/4.+T*(1.03862E-12/5.)))))
      IF(FARR.LE.0.0) GO TO 250
C
      DELH=9.33929E+00+T*(7.25169E-02+T*(1.76645E-03+T*(-7.49572E-06+T*(
     /2.84156E-08+T*(-3.24567E-11)))))
      GO TO 250
C
  220 HA=-1.6984630E+00+T*(1.0189130E+00+T*(-1.3783640E-04/2.+T*(1.98434
     /00E-07/3.+T*(4.2399240E-10/4.+T*(-3.7632490E-13/5.)))))
      IF(FARR.LE.0.0) GO TO 250
C
      DELH=6.2637420E+01+T*(-5.2866570E-01+T*(3.2226230E-03+T*(-2.167025
     /0E-06+T*(2.4951700E-10+T*(3.4891820E-13)))))
      GO TO 250
C
  230 HA=4.7384650E+01+T*(7.9865510E-01+T*(5.3392160E-04/2.+T*(-2.288169
     /0E-07/3.+T*(3.7420860E-11/4.))))
      IF(FARR.LE.0.0) GO TO 250
C
      DELH=-1.7683850E+02+T*(8.3690640E-01+T*(3.6476210E-04+T*(2.5155450
     /E-07+T*(-1.2541340E-10+T*(1.6406270E-14)))))
      GO TO 250
C
  240 HA=1.545856E+01+T*(8.852846E-01+T*(3.702210E-04/2.+T*(-1.349033E-0
     /7/3.+T*(2.368343E-11/4.+T*(-1.580984E-15/5.))))) 
      IF(FARR.LE.0.0) GO TO 250
C
      DELH=7.008344E+01+T*(3.828289E-02+T*(1.357190E-03+T*(-3.390221E-07
     /+T*(4.306526E-11+T*(-2.206248E-15)))))
C
  250 H=HA+FARR*DELH
      GO TO 265
C
  255 H=0.0
      GO TO 265 
C
  260 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      H=CP*T
      GO TO 265
C
  262 H=0.0
C
  265 IF(ND.EQ.2)H=H/CJK
      IF(ND.EQ.3)H=H/2.326
      IF(ND.EQ.3)T=1.8*T

      RETURN
      END

C---------*** Eq.(3); SFT ***---------------------------------------------------
C
      SUBROUTINE SFT(T,F,S)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION SA,DSA
C
      IF(ND.EQ.3)T=T/1.8
      RTEMP=5200.0
      IF (T.GT.RTEMP) T=RTEMP
      IF(CK.NE.0.0)GO TO 360
      IF(F.GT.1.4.AND.F.LE.10.0)GO TO 364
      DSA=0.0
C
      F=ABS(F)
      IF(F.LT.0.10) GO TO 10
      IF(F-1.4)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
    6 F=1.0/F            !  for F= (A/F)
   10 FARR=F/(1.0+F)
C          *********************
      IF(T.LT.0.0) T=ABS(T)
      IF(T.GT.RTEMP) T=RTEMP
      IF(T.LT.1.0)GO TO 355
   12 IF(T-200.)310,14,14
   14 IF(T-800.)320,16,16
   16 IF(T-2200.)330,340,340
C          *********************
C
  310 SA=1.00170E+00*ALOG(T)+T*(3.38308E-06+T*(5.87761E-09/2.+T*(-2.6438
     /7E-10/3.+T*(1.03862E-12/4.))))+9.92163E-01
      IF(FARR.LE.0.0) GO TO 350
C
      DSA=-1.11707E+00+T*(7.32000E-03+T*(-4.24580E-05+T*(1.82696E-07+T*(
     /-3.73792E-10+T*(2.97048E-13)))))
      GO TO 350
C 
  320 SA=1.0189130E+00*ALOG(T)+T*(-1.3783640E-04+T*(1.9843400E-07/2.+T*(
     /4.2399240E-10/3.+T*(-3.7632490E-13/4.))))+9.1992640E-01
      IF(FARR.LE.0.0) GO TO 350
C
      DSA=-7.1269830E-01+T*(-2.2950190E-04+T*(1.3154130E-05+T*(-2.553182
     /0E-08+T*(2.2390990E-11+T*(-7.6071850E-15)))))     
      GO TO 350
C
  330 SA=7.9865510E-01*ALOG(T)+T*(5.3392160E-04+T*(-2.2881690E-07/2.+T*(
     /3.7420860E-11/3.)))+2.0190880E+00
      IF(FARR.LT.0.0) GO TO 350
C
      DSA=-1.2645360E+00+T*(4.4686730E-03+T*(-2.8538180E-06+T*(1.6403460
     /E-09+T*(-5.3143140E-13+T*(6.9884610E-17)))))
      GO TO 350
C
  340 SA=8.852846E-01*ALOG(T)+T*(3.702210E-04+T*(-1.349033E-07/2.+T*(2.3
     /68343E-11/3.+T*(-1.580984E-15/4.))))+1.543854E+00
      IF(FARR.LT.0.0) GO TO 350
C
      DSA=-7.808500E-01+T*(2.800000E-03+T*(-5.432150E-07+T*(6.632280E-11
     /+T*(-3.973220E-15+T*(6.744780E-20)))))
C
  350 S=SA+FARR*DSA
      GO TO 365
C
  355 S=0.0
      GO TO 365
C
  360 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
C
      IF(T.EQ.0.0) GO TO 362
      S = 1.0+CP*LOG(T)
      GO TO 365
C
  362 S=1.0
      GO TO 365
C
  364 S=1.0
C
  365 IF(ND.EQ.2.OR.ND.EQ.3)S=S/CJK
      IF(ND.EQ.3)T=1.8*T
C
      RETURN
      END

C---------*** Eq.(4): PRT ***---------------------------------------------------
C
      SUBROUTINE PRT(T,F,PR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION TC,TX,S0,ST
C
      IF(ND.EQ.3)T=T/1.8
      TC=273.15
      TX=T
C
      CALL SSF(TX,F,ST)
      CALL SSF(TC,F,S0)
C
      PR=EXP((ST-S0)/R)
C
  265 IF(ND.EQ.3)T=1.8*T
C
      RETURN
      END
C******************INTERNAL SUBPROGRAM ; SSF***************************
C
      SUBROUTINE SSF(Y,F,Z)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION Y,SA,DSA,Z
C                   --- T=Y, S=Z ---
      RTEMP=5200.0
      IF(Y.GT.RTEMP)Y=RTEMP
      IF(CK.NE.0.0)GO TO 452
      IF(F.GT.1.4.AND.F.LE.10.0)GO TO 456
      DSA=0.0
C
      F=ABS(F)
      IF(F.LT.0.10) GO TO 10
      IF(F-1.4)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
C
    6 F=1.0/F            !  for F= (A/F)
C
   10 FARR=F/(1.0+F)
C          ********************
      IF(T.LT.0.0) T=ABS(T)
      IF(T.GT.RTEMP) T=RTEMP
      IF(Y.LT.1.0) GO TO 455
   12 IF(Y-200.)410,14,14
   14 IF(Y-800.)420,16,16
   16 IF(Y-2200)430,440,440
C          ********************
C
  410 SA=1.00170E+00*DLOG(Y)+Y*(3.38308E-06+Y*(5.87761E-09/2.+Y*(-2.6438
     /7E-10/3.+Y*(1.03862E-12/4.))))+9.92163E-01
      IF(FARR.LE.0.0) GO TO 450
C
      DSA=-1.11707E+00+Y*(7.32000E-03+Y*(-4.24580E-05+Y*(1.82696E-07+Y*(
     /-3.73792E-10+Y*(2.97048E-13)))))
      GO TO 450
C 
  420 SA=1.0189130E+00*DLOG(Y)+Y*(-1.3783640E-04+Y*(1.9843400E-07/2.+Y*(
     /4.2399240E-10/3.+Y*(-3.7632490E-13/4.))))+9.1992640E-01
      IF(FARR.LE.0.0) GO TO 450
C
      DSA=-7.1269830E-01+Y*(-2.2950190E-04+Y*(1.3154130E-05+Y*(-2.553182
     /0E-08+Y*(2.2390990E-11+Y*(-7.6071850E-15)))))     
      GO TO 450
C
  430 SA=7.9865510E-01*DLOG(Y)+Y*(5.3392160E-04+Y*(-2.2881690E-07/2.+Y*(
     /3.7420860E-11/3.)))+2.0190880E+00
      IF(FARR.LT.0.0) GO TO 450
C
      DSA=-1.2645360E+00+Y*(4.4686730E-03+Y*(-2.8538180E-06+Y*(1.6403460
     /E-09+Y*(-5.3143140E-13+Y*(6.9884610E-17)))))
      GO TO 450
C
  440 SA=8.852846E-01*DLOG(Y)+Y*(3.702210E-04+Y*(-1.349033E-07/2.+Y*(2.3
     /68343E-11/3.+Y*(-1.580984E-15/4.))))+1.543854E+00
      IF(FARR.LT.0.0) GO TO 450
C
      DSA=-7.808500E-01+Y*(2.800000E-03+Y*(-5.432150E-07+Y*(6.632280E-11
     /+Y*(-3.973220E-15+Y*(6.744780E-20)))))
C
  450 Z=SA+FARR*DSA
      GO TO 460
C
  452 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      IF(Y.EQ.0.0) GO TO 455
      Z=1.0+CP*LOG(Y)
      GO TO 460
C
  455 Z=1.0
      GO TO 460
C
  456 Z=1.0
C
  460 RETURN
      END

C---------*** Eq.(5); TFH ***---------------------------------------------------
      SUBROUTINE TFH(X,F,Y)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION HA,DELH,T,TA,H,AH,BH,DH
C
C                 --- X=H,  Y=T ---
      K=0
      IF(ND.EQ.2)X=X*CJK
      IF(ND.EQ.3)X=X*2.326
      IF(CK.NE.0.0)GO TO 568
      IF(F.GT.1.4.AND.F.LE.10.0)GO TO 569
      AH=X
C
      F=ABS(F)
      IF(F.LT.0.10) GO TO 10
      IF(F-1.4)4,4,6
C
    4 F=F/AFST           ! for Phi
      GO TO 10
    6 F=1.0/F            !  for F= (A/F)
   10 FARR=F/(1.0+F)
C
      TA=AH
  500 T=TA
      DELH=0.0
C          *******************
      IF(T.LT.1.0)GO TO 565
   12 IF(T-200.)510,14,14
   14 IF(T-800.)520,16,16
   16 IF(T-2200.)530,540,540
C          ********************
C
  510 HA=-2.18081E-01+T*(1.00170E+00+T*(3.38308E-06/2.+T*(5.87761E-09/3.
     /+T*(-2.64387E-10/4.+T*(1.03862E-12/5.)))))
      IF(FARR.LE.0.0) GO TO 550
C
      DELH=9.33929E+00+T*(7.25169E-02+T*(1.76645E-03+T*(-7.49572E-06+T*(
     /2.84156E-08+T*(-3.24567E-11)))))
      GO TO 550
C
  520 HA=-1.6984630E+00+T*(1.0189130E+00+T*(-1.3783640E-04/2.+T*(1.98434
     /00E-07/3.+T*(4.2399240E-10/4.+T*(-3.7632490E-13/5.)))))
      IF(FARR.LE.0.0) GO TO 550
C
      DELH=6.2637420E+01+T*(-5.2866570E-01+T*(3.2226230E-03+T*(-2.167025
     /0E-06+T*(2.4951700E-10+T*(3.4891820E-13)))))
      GO TO 550
C
  530 HA=4.7384650E+01+T*(7.9865510E-01+T*(5.3392160E-04/2.+T*(-2.288169
     /0E-07/3.+T*(3.7420860E-11/4.))))
      IF(FARR.LE.0.0) GO TO 550
C
      DELH=-1.7683850E+02+T*(8.3690640E-01+T*(3.6476210E-04+T*(2.5155450
     /E-07+T*(-1.2541340E-10+T*(1.6406270E-14)))))
      GO TO 550
C
  540 HA=1.545856E+01+T*(8.852846E-01+T*(3.702210E-04/2.+T*(-1.349033E-0
     /7/3.+T*(2.368343E-11/4.+T*(-1.580984E-15/5.))))) 
      IF(FARR.LE.0.0) GO TO 550
C
      DELH=7.008344E+01+T*(3.828289E-02+T*(1.357190E-03+T*(-3.390221E-07
     /+T*(4.306526E-11+T*(-2.206248E-15)))))
C
  550 H=HA+FARR*DELH
C
      K=K+1
      IF(K.GT.100) GO TO 560
      BH=H
C
      DH=AH-BH
      IF(DABS(DH).LT.1.0e-10) GO TO 560
      TA=TA+DH
      GO TO 500
C
  560 Y=TA
      GO TO 570
C
  565 Y=0.0
      GO TO 570
C
  568 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      Y=X/CP
      GO TO 570
C
  569 Y=0.0
C
  570 IF(ND.EQ.2)X=X/CJK
      IF(ND.EQ.3)X=X/2.326
      IF(ND.EQ.3)Y=1.8*Y
      RETURN
      END

C---------*** Eq.(6); TPR ***--------------------------------------------------
C
      SUBROUTINE TPR(W,F,Z)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION TC,TT,DTT,S00,SSC,SS,DSS
C
C                        --- PR=W,  T=Z ---
      TC=273.15
      IF(CK.NE.0.0) GO TO 26
C
      K=0
      DS=LOG(W)*R
      CALL SSF(TC,F,S00)
      SS=DS+S00
C
      X=LOG(W)
      IF(X.LT.-5.062313)GO TO 11
      T=255.5+X*(56.6+X*(22.1))
      IF(T.LT.550.) T=273.27+X*(77.32+X*(9.842+X*(0.5326)))
   11 IF(T.LT.70.0) T=234.13+X*(52.32+X*(4.367+X*(0.132)))
      IF(T.LT.6.0) T=88.821+X*(12.60+X*(0.6166+X*(0.0103)))
      CALL SFT(T,F,S)
      IF(ND.EQ.2.OR.ND.EQ.3)S=S*CJK
C
      IF(T-400.)12,12,16
   12 IF(T-70.)14,14,15
C
   14 ALF=-48.255+S*(57.72+S*(-21.194+S*(2.766)))
      IF(T.LT.6.0)ALF=-0.33545+S*(2.14093+S*(-1.13907+S*(0.42974)))
      GO TO 18
C
   15 ALF=-3307.8+S*(1895.9+S*(-368.4+S*(24.74)))
      GO TO 18
C
   16 ALF=536.0*S-3350.
C
   18 TT=T
      DTT=0.0
C
   20 TT=TT+DTT
      K=K+1
      IF(K.GT.1000) GO TO 24
      CALL SSF(TT,F,SSC)
      DSS=SS-SSC
      IF(DABS(DSS).LT.1.0e-10) GO TO 24
      DTT=ALF*DSS
      GO TO 20
C
   24 Z=TT
      IF(CK.EQ.0.0) GO TO 30
C
   26 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      Z=Exp(AKR*LOG(W)+LOG(TC))
C
   30 IF(ND.EQ.3)Z=1.8*Z
C
      RETURN
      END
C---------*** Eq.(7); UFT *** --------------------------------------------------
C
      SUBROUTINE UFT(T,F,U)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL HFT(T,F,HU)
      U=HU-T*R
      IF(CK.EQ.0.0) GO TO 10
C
    5 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
C      CP=1.005
C      CKR=CP*AKR
      U=CP*(1.0-AKR)*T
      IF(ND.EQ.2) U=U/CJK
      IF(ND.EQ.3) U=U/2.326/1.8
      GO TO 12
C
   10 IF(ND.EQ.2.OR.ND.EQ.3)U=HU-T*RC
C
   12 RETURN
      END
C---------*** Eq.(8): VRT ***--------------------------------------------------
C
      SUBROUTINE VRT(T,F,VR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL PRT(T,F,PRV)
      VR=T/PRV
C
      RETURN
      END

C -------*** Eq.(9); TFU ***----------------------------------------------------
C
      SUBROUTINE TFU(U,F,T)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      IF(ND.EQ.2)U=U*CJK
      IF(ND.EQ.3)U=2.326*U
      IF (CK.NE.0.0) GO TO 42
C
      T=7.2+1.4*U-1.26e-4*U*U
C
   40 H1=U+T*R
      IF(ND.EQ.2)H1=U/CJK+T*RC
      IF(ND.EQ.3)H1=U/2.326+1.8*T*RC
C
      CALL TFH(H1,F,T1)
      IF(ND.EQ.3)T1=T1/1.8
      DT=T-T1
      IF(ABS(DT).LT.1.0e-5) GO TO 45
      T=T-DT
      GO TO 40
C
   42 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      T=U/(1.0-AKR)/CP
C
   45 IF(ND.EQ.2)U=U/CJK
      IF(ND.EQ.3)U=U/2.326
      IF(ND.EQ.3)T=1.8*T
      RETURN
      END
C---------*** Eq.(10); HVR ***--------------------------------------------------
C
      SUBROUTINE HVR(X,F,Y)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      DOUBLE PRECISION DT,DVR
C
C        --- VR=X ,H=Y ---
      K=0
      IF(CK.NE.0.0) GO TO 40
C
      Z=LOG(X)
      IF(X.GT..12914E+05 )GO TO 19
      T=1964.+Z*(-522.+Z*(38.8))
      IF(T.GT.3000.) T=1933.5+Z*(-654.9+Z*(43.9+Z*(-13.43)))
      IF(T.LT.500.) T=1702.1+Z*(-444.4+Z*(41.64+Z*(-1.3656)))
   19 IF(T.LT.100.) T=1232.9+Z*(-278.25+Z*(21.919+Z*(-0.5956)))
      IF(T.LT.20.) T=434.27+Z*(-72.175+Z*(4.0808+Z*(-0.0781)))
C
      IF(T-250.)20,20,28
   20 IF(T-130.)21,21,26
   21 IF(T-70.)22,22,25
   22 IF(T-63.) 231,231,24
  231 IF(T-20.)232,23,23
C
  232 ALF=(-170.4+Z*(27.9+Z*(-1.5658+Z*(0.0297))))/X
      GO TO 30
   23 ALF=(-359.39+Z*(74.356+Z*(-5.195+Z*(0.1231))))/X
      GO TO 30
   24 ALF=-0.3206+Z*(0.08556+Z*(-0.00761+Z*(2.2562e-4)))
      GO TO 30
   25 ALF=-3.8556+Z*(1.4792+Z*(-0.2126+Z*(0.01356+Z*(-3.2374e-4))))
      GO TO 30
C
   26 ALF=(-703.0+Z*(187.28+Z*(-17.98+Z*(0.597))))/X
      GO TO 30
C
   28 ALF=(-522.+77.6*LOG(X))/X
C
   30 CALL VRT(T,F,VR1)
      DVR=X-VR1
      IF(ABS(DVR).LT.1.0e-6)GO TO 32
C
      DT=ALF*DVR
      T=T+DT
      K=K+1
      IF(K.GT.800) GO TO 32
      GO TO 30
C
   32 CALL HFT(T,F,H)
      Y=H
      GO TO 50
C
   40 VR=X
      AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      TC=273.15
      IF(ND.EQ.3)VR=VR/1.8
C
   41 H=CP*EXP(AK*LOG(TC)-(AK-1.0)*LOG(VR))
      IF(ND.EQ.2) H=H/CJK
      IF(ND.EQ.3) H=H/2.326
      Y=H
C
   50 RETURN
      END
C---------*** Eq.(11); HPR ***----------------------------------------------
C
      SUBROUTINE HPR(PR,F,H)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TPR(PR,F,T)
      CALL HFT(T,F,H)
      RETURN
      END

C---------*** Eq.(12); UPR ***----------------------------------------------
C
      SUBROUTINE UPR(PR,F,U)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TPR(PR,F,T)
      CALL UFT(T,F,U)
      RETURN
      END
C---------*** Eq.(13); UVR ***-----------------------------------------------
C
      SUBROUTINE UVR(VR,F,U)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TVR(VR,F,T)
      CALL UFT(T,F,U)
      RETURN
      END
C---------*** Eq.(14); TVR ***----------------------------------------------
C
      SUBROUTINE TVR(VR,F,T)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL HVR(VR,F,H)
      CALL TFH(H,F,T)
      RETURN
      END
C---------*** Eq.(15); PRH ***----------------------------------------------
C
      SUBROUTINE PRH(H,F,PR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TFH(H,F,T)
      CALL PRT(T,F,PR)
      RETURN
      END
C---------*** Eq.(16); VRH ***-----------------------------------------------
C
      SUBROUTINE VRH(H,F,VR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TFH(H,F,T)
      CALL VRT(T,F,VR)
      RETURN
      END

C---------*** Eq.(17); VRU ***----------------------------------------------
C
      SUBROUTINE VRU(U,F,VR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TFU(U,F,T)
      CALL VRT(T,F,VR)
      RETURN
      END
C---------*** Eq.(18); PRU ***----------------------------------------------
C
      SUBROUTINE PRU(U,F,PR)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
C
      CALL TFU(U,F,T)
      CALL PRT(T,F,PR)
      RETURN
      END
C                                       (( ONE DIMENTIONAL FLOW FUNCTIONS ))
C****************************************************************************
C---------*** Eq.(21); FMN ***-----------------------------------------------
      SUBROUTINE  FMN(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = Mn -----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
C
  101 T=TT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
C
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
    9  CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.0001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 20
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
C
      CPM=CP
      AKRM=AKR
      AKM=AK
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
   20 AMN=Y
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.1000) GO TO 70
      IF(ABS(DT).GT.1E-6) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END
C
      FUNCTION FKMN(AK,AKM,AMN)
      FKMN=1.0+(AK/AKM)*(AKM-1.0)*AMN**2.0/2.0
      RETURN
      END
C********************INTERNAL SUBPROGRAM ; CAL ************************
      SUBROUTINE  CAL(T,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
      BT=1000.0
   80 CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
      CALL PRT(TT,F,TTPR)
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      CALL PRT(T,F,SSPR)
      CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
C
      IF(CK.EQ.0.0) GO TO 20
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      SKR=100.*SQRT(AK/R/BT)
C
   20 TSX=T
      CPMX=CPM
      AKMX=AKM
      AKRMX=AKRM
C
   90 DH=ABS(AHT-AHS)
      V=SQRT(2.0*DH*BT)
C
   30 A=SQRT(AK*R*T*BT)
      IF(ND.EQ.3)A=SQRT(AK*R*BT*T/1.8)
   40 AMN=V/A
C      IF(AMN.LT.0.00001) AMN=0.0
      IF(AMN.GT.0.9992.AND.AMN.LT.1.0003) AMN=1.0
C
   95 DPR=FKMN(AK,AKM,AMN)
C
      AMNX=AMN
C      PSPTX=SSPR/TTPR
C      PTPSX=TTPR/SSPR
C
      PTPSX=DPR**RAKRM
      PSPTX=1.0/PTPSX 
      TSTTX=1.0/DPR
      RSRTX=1.0/DPR**RDKM
      VRTX=V/SQRT(TT)
      IF(ND.EQ.3)VRTX=V/SQRT(TT)/0.3048
      QX=SKR*AMN/DPR**RK2DKM
      QSX=SKR*AMN*SQRT(DPR)
C
      IF(AMN.LT.0.00001)GO TO 96
      ATAS=AMN*((1.0+RAKSM/RDKM/2.0)/DPR)**RK2DKM
      ASATX=1.0/ATAS
      GO TO 98
   96 ASATX=0.0
C
   98 IF(ND.EQ.2.OR.ND.EQ.3)CPMX=CPMX/CJK
      IF(ND.EQ.2)QX=QX*G/100.
      IF(ND.EQ.3)QX=0.1315707*QX
      IF(ND.EQ.2)QSX=QSX*G/100.
      IF(ND.EQ.3)QSX=0.1315707*QSX
C
      RETURN
      END

C---------*** Eq.(22); PSR ***-----------------------------------------------
       SUBROUTINE  PSR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
      DOUBLE PRECISION DPTPS,PTPSY,PTPS
C
C                              -----  Y = Ps/Pt  -----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
C
  102 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.0001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 25
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
      AMN=SQRT(2.0*RDKM*((1.0/Y)**AKRM-1.0))
      GO TO 65
C
   25 PSPT=Y
      IF(PSPT.GT.1.0) PSPT=1.0
      PTPS=1.0/PSPT
      IF(PTPS.LT.1.02)GO TO 34
      IF(JACK.NE.0) GO TO 31
C
   30 PTPSY=PTPS
      Z=LOG(PTPS)
      AMN=SQRT(2.0*RDKM/RAKSM*(PTPS**AKRM-1.0))
   31 ALF=EXP(1.45+AMN*(-2.36+AMN*(0.2+AMN*(-0.009))))/2.0
      IF(AMN.GT.4.0)ALF=EXP(1.129+AMN*(-2.103+AMN*(0.141+AMN*(-0.0045)))
     /)/20.0
      IF(TT.GT.3000.)ALF=ALF/2.0 
      IF(AMN.GT.20)ALF=ALF*10000.
C
      K=0 
   32 BMN=AMN
      CALL FMN(AMN,F,TT)
      PTPS=PTPSX
      DPTPS=PTPSY-PTPS
      AMN=AMN+ALF*DPTPS
C
      DMN=BMN-AMN
      IF(ABS(DMN).LT.1e-6) GO TO 65
      IF(K.GT.2000) GO TO 65
      K=K+1
      GO TO 32
C
   34 AMN=SQRT(2.0/AK*ABS(PTPS-1.0))
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.30) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END

C---------***Eq.(23); PTR***--------------------------------------------
       SUBROUTINE  PTR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
      DOUBLE PRECISION DPTPS,PTPSY,PTPS
C                             -----  Y = Pt/Ps -----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
C
  103 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 28 
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
      AMN=SQRT(2.0*RDKM*(Y**AKRM-1.0))
      GO TO 65
C
   28 PTPS=Y
      IF(PTPS.LT.1.0) PTPS=1.0
      IF(PTPS.LT.1.02)GO TO 34
      IF(JACK.NE.0) GO TO 31
C
   30 PTPSY=PTPS
C
      Z=LOG(PTPS)
      AMN=SQRT(2.0*RDKM/RAKSM*(PTPS**AKRM-1.0))
   31 ALF=EXP(1.45+AMN*(-2.36+AMN*(0.2+AMN*(-0.009))))/2.0
      IF(AMN.GT.4.0)ALF=EXP(1.158+AMN*(-2.106+AMN*(0.136+AMN*(-0.0041)))
     /)/20.0
      IF(TT.GT.3000.)ALF=ALF/2.0
      IF(AMN.GT.20.0)ALF=ALF*100.0 
C
      K=0
   32 BMN=AMN
      CALL FMN(AMN,F,TT)
      PTPS=PTPSX
      DPTPS=PTPSY-PTPS
      AMN=AMN+ALF*DPTPS
C
      DMN=BMN-AMN
      IF(ABS(DMN).LT.1e-5) GO TO 65
      IF(K.GT.2000) GO TO 65
      K=K+1
      GO TO 32
C
   34 AMN=SQRT(2.0/AK*ABS(PTPS-1.0))
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END

C---------*** Eq.(24); TSR ***-------------------------------------------
       SUBROUTINE  TSR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = Ts/Tt , AMNL=31 -----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
  104 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 35
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
      AMN=SQRT(2.0*RDKM*(1.0/Y-1.0))
      GO TO 65
C
   35 TSTT=Y
      TTTS=1.0/TSTT
      IF(TSTT.GT.1.0) TSTT=1.0
      TSTTY=TSTT
      IF(TTTS.LT.1.0002)GO TO 38
C
      X=LOG(Y)
      AMN=0.32-3.49*X-1.13*X**2-0.356*X**3
C
   36 BMN=AMN
      DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
C
      DTSTT=TSTT-TSTTY
      AMN=AMN+0.5*DTSTT
C
      DMN=BMN-AMN
      IF(ABS(DMN).LT.1e-6) GO TO 65
      GO TO 36
C
   38 AMN=SQRT((2.0/AK)*RAKRM*ABS(TTTS-1.0))
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END

C--------*** Eq.(25); RSR *** -----------------------------------------
       SUBROUTINE  RSR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                      -----  Y = (Rho)s/(Rho)t ,AMNL=32-----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
  105 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 38
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
C
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
      AMN=SQRT(2.0*RDKM*((1.0/Y)**(AKM-1.0)-1.0))
      GO TO 65
C
   38 RSRT=Y
      IF(RSRT.GT.1.0) RSRT=1.0
      RSRTY=RSRT
      IF(RSRT.GT.0.999) GO TO 42
      IF(JACK.NE.0) GO TO 40
C
      X=LOG(Y)
      AMN=0.39386+X*(-1.05362+X*(-0.07262+X*(-0.00805)))
   40 ALF=EXP(-1.76846+AMN*(1.90134+AMN*(-0.07378+AMN*(0.00112))))/100.
      IF(AMN.GT.20.0)ALF=ALF/100.0
C
      K=0
   41 BMN=AMN
      DPR=FKMN(AK,AKM,AMN)
      RSRT=1.0/(DPR**RDKM)
C
      DRSRT=RSRT-RSRTY
      AMN=AMN+ALF*DRSRT
C
      DMN=BMN-AMN
      IF(ABS(DMN).LT.1e-6) GO TO 65
      IF(K.GT.10000) GO TO 65
      K=K+1
      GO TO 41
C
   42 AMN=SQRT(2.0*RAKSM*ABS(1.0-RSRT))
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END

C---------***Eq.(26); VFT----------------------------------------------
       SUBROUTINE  VFT(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = V/SQRT(Tt), AMNL=25  -----
      IF(ND.EQ.3)Y=Y/2.4454
      Y=ABS(Y)
      BT=1000.0
      JACK=0
C
  106 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 42
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
      AMN=Y/SQRT((AK-1.0)*(CP*BT-Y**2.0/2.0))
      GO TO 65
C
   42 VPRT=Y
      IF(VPRT.LT.0.0) VPRT=0.0
      IF(VPRT.LT.0.2) GO TO 48
      IF(JACK.NE.0) GO TO 45
      VPRTY=VPRT
      AMN=-0.617+0.4*Y-0.056*Y**2+0.0037*Y**3-1.047e-4*Y**4+1.08e-6*Y**5
      IF(AMN.GT.10.0)AMN=10.0+1.7*(Y-43.7)
C
   45 ALF=0.001
      IF(AMN.GT.0.1)ALF=0.01
      IF(AMN.GT.1.6)ALF=0.1 
      IF(AMN.GT.15.0)ALF=1.0
C
      K=0
   46 BMN=AMN
      DPR=FKMN(AK,AKM,AMN)
      VPRT=RKR*AMN/SQRT(DPR)
C
      DVPRT=VPRTY-VPRT
      AMN=AMN+ALF*DVPRT
C
      DMN=BMN-AMN
      IF(K.GT.2000) GO TO 65
      IF(ABS(DMN).LT.1e-6) GO TO 65
C
      K=K+1
      GO TO 46
C
   48 AMN=VPRT/SQRT(AK*BT*R)
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.200) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      IF(ND.EQ.3)Y=2.4454*Y
      RETURN
      END

C---------*** Eq.(27a); FQT ***------------------------------------------
      SUBROUTINE  FQT(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = Qt  -----
      IF(ND.EQ.2) Y=100.*Y/G
      IF(ND.EQ.3)Y=Y/0.1315707
      Y=ABS(Y)
      BT=1000.0
      JACK=0
  107 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 48
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
   48 Q=Y
      QY=Q
C
      IF(Q.LT.0.3) GO TO 54
C
      AMN=-0.0012+Y*(0.3091+Y*(-0.3917+Y*(0.3076+Y*(-0.0966+Y*(0.0107)))
     /))
C      IF(Y.GT.3.9)AMN=-5756.3+Y*(4378.1+Y*(-1109.9+Y*(93.81)))
   50 X=AMN
      ALF=-0.107+X*(7.085+X*(-54.27+X*(167.6+X*(-221.5+X*(105.82)))))/2.
     /0
      IF(AMN.GT.1.0) AMN=1.0
C
      K=0
   51 BMN=AMN
      DPR=FKMN(AK,AKM,AMN)
      Q=(SKR*AMN)/DPR**RK2DKM
      IF(AMN.GE.1.0) Q=2.0*QY-Q
C
      DQ=QY-Q
      AMN=AMN+ALF*DQ
C
   52 DMN=BMN-AMN
      K=K+1
      IF(ABS(DMN).LT.1e-6) GO TO 65
      IF(Y.GT.3.85.AND.K.GE.2000) GO TO 65
      IF(K.GT.1000) GO TO 65
      GO TO 51
C
   54 AMN=Q/SQRT(10.0*AK/R)
      GO TO 65
C
   64 AMN=1.0
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      IF(ND.EQ.2)Y=Y*G/100.
      IF(ND.EQ.3)Y=0.1315707*Y
      RETURN
      END
C
C---------*** Eq.(27b); SFQT ***----------------------------------------
      SUBROUTINE  SFQT(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                        ----- Y = Qt ,AMNL=25-----
      IF(ND.EQ.2)Y=100.*Y/G
      IF(ND.EQ.3)Y=Y/0.1315707
      Y=ABS(Y)
      BT=1000.0
      JACK=0
  107 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 53
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
   53 Q=Y
      IF(Q.GT.4.1) Q=4.1
      QY=Q
C
      IF(Y.LT.0.001) GO TO 34
      IF(Y.LT.0.03) GO TO 33
      IF(Y.LT.1.0) GO TO 32
      IF(JACK.NE.0) GO TO 40
C
   30 AMN=4.48+Y*(-2.1+Y*(0.65+Y*(-0.084)))   
      GO TO 36
C
   32 AMN=8.48+Y*(-40.0+Y*(137.8+Y*(-202.0+Y*(100.0))))
      GO TO 36
   33 AMN=11.469+Y*(-234.02+Y*(3955.3+Y*(-24076.7)))
      GO TO 36
C
   34 Z=LOG(Y)
      AMN=0.90416+Z*(-1.32753+Z*(-0.06744+Z*(-0.00636)))
      ALF=EXP(-1.87389+AMN*(1.34634+AMN*(-0.03633+AMN*(4.26668E-4))))
      GO TO 40
C
   36 ALF=EXP(-2.33+AMN*(0.62+AMN*(0.09+AMN*(-0.0075))))/2.0
C
   40 K=0
   54 BMN=AMN
C
      DPR=FKMN(AK,AKM,AMN)
      Q=(SKR*AMN)/DPR**RK2DKM
      DQ=QY-Q
      AMN=AMN-ALF*DQ
C
      DMN=BMN-AMN
      K=K+1
      IF(ABS(DMN).LT.1e-7) GO TO 65
      IF(Y.GT.3.85.AND.K.GE.5000) GO TO 64
      IF(K.GT.10000) GO TO 65
      GO TO 54
C
   64 AMN=1.0
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      IF(ND.EQ.2)Y=Y*G/100.
      IF(ND.EQ.3)Y=0.1315707*Y
      RETURN
      END

C---------***Eq.(28); FQS ***------------------------------------------
       SUBROUTINE  FQS(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = Qs ,AMNL=31 -----
      IF(ND.EQ.2) Y=100.*Y/G
      IF(ND.EQ.3) Y=Y/0.1315707
C
      Y=ABS(Y)
      BT=1000.0
      JACK=0
C
  108 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 50
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
      AMN=SQRT((SQRT(1.0+2.0*(AK-1.0)*(Y/SKR)**2)-1.0)/(AKM-1.0))
      GO TO 65
C
   50 QS=Y
      QSY=QS
      IF(QS.LT.0.04) GO TO 60
      IF(QS.GT.20.) GO TO 56
      IF(JACK.NE.0) GO TO 55
C
      AMN=0.287+Y*(0.0905+Y*(-4.93e-4+Y*(1.16e-6)))
      X=AMN
   55 ALF=0.156+X*(-0.055+X*(0.00815+X*(-4.28e-4)))/5.
      GO TO 57
C
   56 Z=LOG(Y)
      AMN=0.52179+Z*(-0.83502+Z*(0.75832+Z*(-0.14626+Z*(0.01542))))
      X=AMN
C      ALF=EXP(-1.77005+X*(-0.48716+X*(0.03963+X*(-0.00188+X*(4.5634E-5+
C     /X*(-4.37066E-7))))))
C
      ALF=EXP(-2.51334+X*(-0.23512+X*(0.00872+X*(-1.32944E-4))))
      IF(AMN.LE.4.0)ALF=EXP(-1.88416+X*(-0.12279+X*(-0.13088+X*(0.01402)
     /)))
C
   57 K=0
   58 BMN=AMN
      CALL FMN(AMN,F,TT)
      IF(ND.EQ.2)QSX=QSX*100./G
      IF(ND.EQ.3)QSX=QSX/0.1315707
      QS=QSX
      DQS=QSY-QS
      AMN=AMN+ALF*DQS
C
      DMN=BMN-AMN
      IF(ABS(DMN).LT.1e-4) GO TO 65
      IF(K.GT.2000) GO TO 65
      K=K+1
      GO TO 58
C
   60 AMN=QS/SQRT(10.0*AK/R)
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-3) GO TO 4
C
   70 CALL CAL(T,F,TT)
      IF(ND.EQ.2)Y=Y*G/100.
      IF(ND.EQ.3)Y=0.1315707*Y
      RETURN
      END

C---------*** Eq.(29a); ASR ***----------------------------------------
      SUBROUTINE  ASR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                             -----  Y = As/Ach -----
      Y=ABS(Y)
      BT=1000.0
      JACK=0
  109 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
C
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 58
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
   58 ASAT=Y
      IF(Y.NE.0.0) GO TO 38
      IF(Y.EQ.0.0)ATAS=1e8
      GO TO 39
C
   38 ATAS=1.0/Y
   39 IF(ASAT.EQ.1.0) GO TO 40
      IF(ASAT.GT.20.0)GO TO 46
      IF(Y.EQ.0.0) GO TO 42
      IF(JACK.NE.0) GO TO 60
C
      ATASY=ATAS
      Z=ATAS
C
      AMN=-0.0012+Z*(1.2554+Z*(-6.464+Z*(20.48+Z*(-25.94+Z*(11.64)))))
      IF(Z.GT.0.95)AMN=-2160.4+Z*(6719.1+Z*(-6965.0+Z*(2407.3)))
      X=AMN
   60 ALF=-0.5+X*(30.5+X*(-233.5+X*(720.7+X*(-951.8+X*(454.2)))))
      IF(AMN.GT.0.99)ALF=100.0
C
      K=0
   61 BMN=AMN
C
      IF(AMN.LT.0.001)GO TO 42
      CALL FMN(AMN,F,TT)
      ASAT=ASATX
      ATAS=1.0/ASAT
      GO TO 44
C
   40 AMN=1.0
      GO TO 65
C
   42 AMN=0.0
      GO TO 65
C
   44 DATAS=ATASY-ATAS
      AMN=AMN+ALF*DATAS
C
      DMN=BMN-AMN
      K=K+1
      IF(ABS(DMN).LT.1e-5) GO TO 65
      IF(AMN.GT.0.9999)GO TO 64
      IF(K.GT.1000) GO TO 65
      GO TO 61
C
   46 AMN=0.59/ASAT
      GO TO 65
C
   63 AMN=0.0
      GO TO 65
   64 AMN=1.0
C
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.10) GO TO 70
      IF(ABS(DT).GT.1E-3) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END

C---------*** Eq.(29b); SASR ***----------------------------------------
      SUBROUTINE  SASR(Y,F,TT)
C
      COMMON/SYIAE/RC,R,AFST,CK,ND,G,CJK,AKR
      COMMON/SHEN/TSX,CPMX,AKMX,AKRMX
      COMMON/YANG/AMNX,PSPTX,PTPSX,TSTTX,RSRTX,VRTX,QX,QSX,ASATX
      COMMON/WSW/SKR,RAKRM,RDKM,RK2DKM,R2KM,RAKSM,CPM,AKRM,AKM
C
C                              -----  Y = As/Ach  -----
      BT=1000.0
      JACK=0
C
  109 T=TT
      CALL HFT(TT,F,AHT)
      IF(ND.EQ.2)AHT=AHT*CJK
      IF(ND.EQ.3)AHT=2.326*AHT
C
    4 TA=T
    6 CALL CPT(T,F,CP,AK)
      IF(ND.EQ.2.OR.ND.EQ.3)CP=CP*CJK
      RKR=SQRT(AK*R*BT)
      SKR=100.*SQRT(AK/R/BT)
C
      CALL HFT(T,F,AHS)
      IF(ND.EQ.2)AHS=AHS*CJK
      IF(ND.EQ.3)AHS=2.326*AHS
      DDT=TT-T
      IF(ABS(DDT).GT.0.001)GO TO 7
      CPM=CP
      GO TO 8
C
    7 CPM=(AHT-AHS)/DDT
      IF(ND.EQ.3)CPM=1.8*(AHT-AHS)/DDT
      IF(CPM.LT.0.8) CPM=0.8
      IF(CK.GT.0.0) GO TO 10
C
    8 AKRM=R/CPM
      AKM=1.0/(1.0-AKRM)
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      GO TO 28
C
   10 AK=CK
      AKR=(AK-1.0)/AK
      AKRR=AK/(AK-1.0)
      CP=AKRR*R
      CPM=CP
      AKRM=AKR
      AKM=AK
C
      RAKRM=1.0/AKRM
      RDKM=1.0/(AKM-1.0)
      RK2DKM=(AKM+1.0)/(AKM-1.0)/2.0
      R2KM=2.0/(AKM+1.0)
      RAKSM=AK/AKM
      SKR=100.*SQRT(AK/R/BT)
C
   28 Y=ABS(Y)
      ASAT=Y
      IF(ASAT.LT.1.0) ASAT=1.0
      ATAS=1.0/Y
      ATASY=ATAS
      IF(JACK.NE.0) GO TO 34
C      
   30 AMN=-0.64+Y*(2.2+Y*(-0.45+Y*(+0.032)))
      IF(AMN.GT.3.0) GO TO 32
      GO TO 34
C
   32 X=LOG(Y)
      AMN=1.31249+X*(1.25711+X*(-0.07877+X*(0.01571)))
C
   34 X=AMN
      ALF=3.97+X*(0.817+X*(-1.96+X*(0.569)))/2.0
      GO TO 38
C
   36 ALF=EXP(1.65718+AMN*(-1.21293+AMN*(0.06778+AMN*(-0.0021+AMN*(2.551
     /74E-5)))))
   38 K=0
C
   63 BMN=AMN
      DPR=FKMN(AK,AKM,AMN)
      ATAS=AMN*((1.0+(AK/AKM)*(AKM-1.0)/2.0)/DPR)**RK2DKM
      ASAT=1.0/ATAS
C
      DATAS=ATASY-ATAS
      AMN=AMN-ALF*DATAS
C
      DMN=BMN-AMN
      K=K+1
      IF(ABS(DMN).LT.1e-6) GO TO 65
      IF(AMN.GT.0.99999.AND.AMN.LT.1.0001) GO TO 64
      IF(K.GT.500) GO TO 65
      GO TO 63
C
   64 AMN=1.0
   65 DPR=FKMN(AK,AKM,AMN)
      TSTT=1.0/DPR
      T=TT*TSTT
      DT=TA-T
C
      JACK=JACK+1
      IF(JACK.GE.100) GO TO 70
      IF(ABS(DT).GT.1E-5) GO TO 4
C
   70 CALL CAL(T,F,TT)
      RETURN
      END
C----------------------------------------------------------------------